------------------------------------------------------------------------------
-- MakeMeGetMyMain - Alarms you when something happens to your character
------------------------------------------------------------------------------
-- Trigger_Whisper.lua - Triggered if character receives a whisper
--
-- Author: Expelliarm5s / June 2022 / All Rights Reserved
--
-- Version 1.1.15
------------------------------------------------------------------------------
-- luacheck: ignore 212 globals DLAPI

local addonName, addon = ...
local modle = addon:NewModule("Whisper", "AceEvent-3.0", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale(addonName)
-- local private = {}
------------------------------------------------------------------------------

function modle:ModuleName()
	return modle.moduleName
end

function modle:ToggleMod()
	addon.db.global[modle.moduleName] = addon.db.global[modle.moduleName] or false
	addon.db.global[modle.moduleName] = not addon.db.global[modle.moduleName]
	if addon.db.global[modle.moduleName] then
		addon:Printf(L["Module %s enabled"], modle.moduleName)
	else
		addon:Printf(L["Module %s disabled"], modle.moduleName)
	end
end

function modle:EnableMod()
	addon.db.global[modle.moduleName] = true
	addon:Printf(L["Module %s enabled"], modle.moduleName)
end

function modle:DisableMod()
	addon.db.global[modle.moduleName] = false
	addon:Printf(L["Module %s disabled"], modle.moduleName)
end

function modle:ModuleIcon()
	if addon.isClassic then
		return "INTERFACE\\ICONS\\Ability_Warrior_WarCry"
	else
		return "INTERFACE\\ICONS\\Warrior_DisruptingShout"
	end
end

function modle:TriggerName()
	return L["Character got whispers!"]
end

function modle:TriggerDesc()
	return L["Alarm fires on receiving whispers."]
end

function modle:Login()
	modle:RegisterEvent("CHAT_MSG_WHISPER")
end

function modle:CHAT_MSG_WHISPER(event, arg1, arg2)
	addon:DebugPrintf(modle.moduleName .. "~  %s: '%s' from %s", tostring(event), tostring(arg1), tostring(arg2))
	if addon.isEnabled and addon.db.global[modle.moduleName] then
		addon:DebugPrintf(modle.moduleName .. "~  -> GUI:Fire(%s)", modle.moduleName)
		addon:Printf(format(L["Module %s: %s (from %s)"], modle.moduleName, modle:TriggerName(), tostring(arg2)))
		if addon.GUI.Fire then
			addon.GUI:Fire(modle.moduleName, nil, format("%s: |cffffffff%s|r", tostring(arg2), tostring(arg1)))
		end
	end
end

-- EOF